_G.RndHeistChain = _G.RndHeistChain or {}

RndHeistChain.menu_id = "rnd_heist_chain_menu_id"
RndHeistChain.ModPath = ModPath
RndHeistChain.SaveFile = RndHeistChain.SaveFile or SavePath .. "RndHeistChain.txt"

function RndHeistChain:Reset()
	self.settings = {{"Nah"}}
	self:Save()
end

function RndHeistChain:Load()
	local _file = io.open(self.SaveFile, "r")
	if _file then
		self.settings = json.decode(_file:read("*all"))
		_file:close()
	else
		self:Reset()
	end
end

function RndHeistChain:Save()
	local _file = io.open(self.SaveFile, "w+")
	if _file then
		_file:write(json.encode(self.settings))
		_file:close()
	end
end

Hooks:Add("MenuManagerSetupCustomMenus", "MenuManagerSetupCustomMenus_RndHeistChain", function(menu_manager, nodes)
	if nodes.lobby then
		MenuHelper:NewMenu(RndHeistChain.menu_id)
	end
end)

Hooks:Add("MenuManagerPopulateCustomMenus", "MenuManagerPopulateCustomMenus_RndHeistChain", function(menu_manager, nodes)
	if nodes.lobby then
		MenuCallbackHandler.CleanRndHeistChainNow = function(self, item)
			RndHeistChain:Reset()
			QuickMenu:new(
				"Random Heist Chain",
				"Data is removed",
				{
					{"Ok", is_cancel_button = true}
				},
				true
			):Show()
		end
		MenuCallbackHandler.GetRndHeistChainNow = function(self, item)
			if tweak_data and tweak_data.narrative and tweak_data.levels then
				local _create_job = function()
					local _difficulty = Global.game_settings.difficulty or "overkill_290"
					local _difficulty_id = tweak_data:difficulty_to_index(_difficulty)
					managers.money:on_buy_premium_contract("branchbank", _difficulty_id)
					managers.job:on_buy_job("branchbank", _difficulty_id)
					MenuCallbackHandler:start_job({job_id = "branchbank", difficulty = _difficulty})
					MenuCallbackHandler:save_progress()
				end
				local _ok2use = {}
				local _blocklevel = {
					welcome_to_the_jungle_2 = true,
					short1_stage1 = true,
					short1_stage2 = true,
					short2_stage1 = true,
					short2_stage2b = true,
					chill = true,
					chill_combat = true,
					watchdogs_2_day = true,
					watchdogs_2 = true,
					alex_3 = true,
					safehouse = true,
					peta2 = true,
					mia2_new = true
				}				
				for i, _level_id in pairs(tweak_data.levels.escape_levels) do
					_blocklevel[_level_id] = true
				end
				for i, _level_id in pairs(tweak_data.levels:get_level_index()) do
					if not _blocklevel[_level_id] then
						table.insert(_ok2use, _level_id)
					end				
				end
				_blocklevel = {}
				tweak_data.narrative.jobs.branchbank.chain = {}
				local _u = 0
				while _u < 3 do
					_level_id = _ok2use[math.random(#_ok2use)]
					if not _blocklevel[_level_id] then
						_u = _u + 1
						_blocklevel[_level_id] = true
						tweak_data.narrative.jobs.branchbank.chain[_u] = {level_id = _level_id, type_id = "heist_type_assault", type = "d",}
					end				
				end
				math.randomseed(tostring(os.time()):reverse():sub(1, 6))
				RndHeistChain.settings = tweak_data.narrative.jobs.branchbank.chain
				RndHeistChain:Save()
				_create_job()
			end
		end
		MenuHelper:AddButton({
			id = "GetRndHeistChainNow",
			title = "menu_rndheistchain_contract_name",
			desc = "menu_rndheistchain_contract_desc",
			callback = "GetRndHeistChainNow",
			menu_id = RndHeistChain.menu_id,
		})
		MenuHelper:AddButton({
			id = "CleanRndHeistChainNow",
			title = "menu_rndheistchain_clean_name",
			desc = "menu_rndheistchain_clean_desc",
			callback = "CleanRndHeistChainNow",
			menu_id = RndHeistChain.menu_id,
		})
	end
end)

RndHeistChain:Load()

if RndHeistChain.settings and RndHeistChain.settings[2] then
	tweak_data.narrative.jobs.branchbank.chain = RndHeistChain.settings
end

Hooks:Add("MenuManagerBuildCustomMenus", "MenuManagerBuildCustomMenus_RndHeistChain", function(menu_manager, nodes)
	if nodes.lobby then
		nodes[RndHeistChain.menu_id] = MenuHelper:BuildMenu(RndHeistChain.menu_id)
		MenuHelper:AddMenuItem(nodes.lobby, RndHeistChain.menu_id, "menu_rndheistchain_contract_name", "menu_rndheistchain_contract_desc")
	end
end)

Hooks:Add("LocalizationManagerPostInit", "RndHeistChain_loc", function(loc)
	LocalizationManager:add_localized_strings({
		["menu_rndheistchain_contract_name"] = "Get Random Heist Chain",
		["menu_rndheistchain_contract_desc"] = " ...",
		["menu_rndheistchain_clean_name"] = "Clean Random Heist Chain",
		["menu_rndheistchain_clean_desc"] = " ...",
	})
end)